package betterwithmods.client;

import betterwithmods.api.block.IAdvancedRotationPlacement;
import betterwithmods.client.gui.GuiStatus;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.BufferBuilder;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.RayTraceResult;
import net.minecraft.world.World;
import net.minecraftforge.client.event.DrawBlockHighlightEvent;
import net.minecraftforge.client.event.RenderGameOverlayEvent;
import net.minecraftforge.event.entity.player.ItemTooltipEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import org.lwjgl.opengl.GL11;

/**
 * Created by primetoxinz on 6/7/17.
 */
public class ClientEventHandler {
    Minecraft mc = Minecraft.func_71410_x();

    @SideOnly(Side.CLIENT)
    @SubscribeEvent
    public void putTooltip(ItemTooltipEvent e) {

    }


    @SideOnly(Side.CLIENT)
    @SubscribeEvent
    public void onBlockHighlight(DrawBlockHighlightEvent event) {
        EntityPlayer player = event.getPlayer();
        ItemStack stack = ItemStack.field_190927_a;
        if ((player.func_184586_b(EnumHand.MAIN_HAND).func_190926_b() || !(player.func_184586_b(EnumHand.MAIN_HAND).func_77973_b() instanceof ItemBlock)) && !player.func_184586_b(EnumHand.OFF_HAND).func_190926_b()) {
            stack = player.func_184586_b(EnumHand.OFF_HAND);
        } else if (!player.func_184586_b(EnumHand.MAIN_HAND).func_190926_b()) {
            stack = player.func_184586_b(EnumHand.MAIN_HAND);
        }
        Block block = Block.func_149634_a(stack.func_77973_b());
        if (event.getTarget().field_72313_a == RayTraceResult.Type.BLOCK && block instanceof IAdvancedRotationPlacement) {
            World world = player.func_130014_f_();
            EnumFacing side = event.getTarget().field_178784_b;

            BlockPos pos = event.getTarget().func_178782_a();
            IBlockState iblockstate = world.func_180495_p(pos);

            if (world.func_180495_p(pos.func_177972_a(side)).func_185904_a().func_76222_j() && iblockstate.func_185904_a() != Material.field_151579_a && world.func_175723_af().func_177746_a(pos)) {
                double dx = (player.field_70142_S + (player.field_70165_t - player.field_70142_S) * (double) event.getPartialTicks());
                double dy = (player.field_70137_T + (player.field_70163_u - player.field_70137_T) * (double) event.getPartialTicks());
                double dz = (player.field_70136_U + (player.field_70161_v - player.field_70136_U) * (double) event.getPartialTicks());
                float x = (float) event.getTarget().field_72307_f.field_72450_a - pos.func_177958_n();
                float y = (float) event.getTarget().field_72307_f.field_72448_b - pos.func_177956_o();
                float z = (float) event.getTarget().field_72307_f.field_72449_c - pos.func_177952_p();
                BlockPos renderPos = pos.func_177972_a(side);

                IBlockState placeState = ((IAdvancedRotationPlacement) block).getRenderState(world,renderPos,side,x,y,z,stack.func_77960_j(),player);
                GlStateManager.func_179094_E();

                GlStateManager.func_179147_l();
                GlStateManager.func_187428_a(GlStateManager.SourceFactor.SRC_ALPHA, GlStateManager.DestFactor.ONE_MINUS_SRC_ALPHA, GlStateManager.SourceFactor.ONE, GlStateManager.DestFactor.ZERO);

                Tessellator tessellator = Tessellator.func_178181_a();
                BufferBuilder buffer = tessellator.func_178180_c();
                buffer.func_178969_c(-dx,-dy,-dz);
                renderBlock(placeState, renderPos, world);
                buffer.func_178969_c(0,0,0);

                GlStateManager.func_179084_k();
                GlStateManager.func_179121_F();
            }
        }
    }

    public void renderBlock(IBlockState state, BlockPos pos, World world) {
        Tessellator tessellator = Tessellator.func_178181_a();
        BufferBuilder buffer = tessellator.func_178180_c();

        this.mc.func_110434_K().func_110577_a(TextureMap.field_110575_b);
        buffer.func_181668_a(GL11.GL_QUADS,DefaultVertexFormats.field_176600_a);
        mc.func_175602_ab().func_175018_a(state,pos,world,buffer);
        tessellator.func_78381_a();
    }

    @SideOnly(Side.CLIENT)
    @SubscribeEvent
    public void renderStatus(RenderGameOverlayEvent.Post event) {
        if (event.getType() == RenderGameOverlayEvent.ElementType.TEXT) {
            GuiStatus.INSTANCE.draw();
        }
    }
}

